// Code generated by protoc-gen-go. DO NOT EDIT.
// source: author.proto

package proto

import (
	context "context"
	fmt "fmt"
	proto "github.com/golang/protobuf/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	math "math"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion3 // please upgrade the proto package

type Author struct {
	Id                   string   `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	Name                 string   `protobuf:"bytes,2,opt,name=name,proto3" json:"name,omitempty"`
	Email                string   `protobuf:"bytes,3,opt,name=email,proto3" json:"email,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *Author) Reset()         { *m = Author{} }
func (m *Author) String() string { return proto.CompactTextString(m) }
func (*Author) ProtoMessage()    {}
func (*Author) Descriptor() ([]byte, []int) {
	return fileDescriptor_54cb4b5a5dd8ee3d, []int{0}
}

func (m *Author) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_Author.Unmarshal(m, b)
}
func (m *Author) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_Author.Marshal(b, m, deterministic)
}
func (m *Author) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Author.Merge(m, src)
}
func (m *Author) XXX_Size() int {
	return xxx_messageInfo_Author.Size(m)
}
func (m *Author) XXX_DiscardUnknown() {
	xxx_messageInfo_Author.DiscardUnknown(m)
}

var xxx_messageInfo_Author proto.InternalMessageInfo

func (m *Author) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func (m *Author) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *Author) GetEmail() string {
	if m != nil {
		return m.Email
	}
	return ""
}

type AuthorInput struct {
	Name                 string   `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	Email                string   `protobuf:"bytes,2,opt,name=email,proto3" json:"email,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AuthorInput) Reset()         { *m = AuthorInput{} }
func (m *AuthorInput) String() string { return proto.CompactTextString(m) }
func (*AuthorInput) ProtoMessage()    {}
func (*AuthorInput) Descriptor() ([]byte, []int) {
	return fileDescriptor_54cb4b5a5dd8ee3d, []int{1}
}

func (m *AuthorInput) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AuthorInput.Unmarshal(m, b)
}
func (m *AuthorInput) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AuthorInput.Marshal(b, m, deterministic)
}
func (m *AuthorInput) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AuthorInput.Merge(m, src)
}
func (m *AuthorInput) XXX_Size() int {
	return xxx_messageInfo_AuthorInput.Size(m)
}
func (m *AuthorInput) XXX_DiscardUnknown() {
	xxx_messageInfo_AuthorInput.DiscardUnknown(m)
}

var xxx_messageInfo_AuthorInput proto.InternalMessageInfo

func (m *AuthorInput) GetName() string {
	if m != nil {
		return m.Name
	}
	return ""
}

func (m *AuthorInput) GetEmail() string {
	if m != nil {
		return m.Email
	}
	return ""
}

type AuthorInputID struct {
	Id                   string   `protobuf:"bytes,1,opt,name=id,proto3" json:"id,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *AuthorInputID) Reset()         { *m = AuthorInputID{} }
func (m *AuthorInputID) String() string { return proto.CompactTextString(m) }
func (*AuthorInputID) ProtoMessage()    {}
func (*AuthorInputID) Descriptor() ([]byte, []int) {
	return fileDescriptor_54cb4b5a5dd8ee3d, []int{2}
}

func (m *AuthorInputID) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_AuthorInputID.Unmarshal(m, b)
}
func (m *AuthorInputID) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_AuthorInputID.Marshal(b, m, deterministic)
}
func (m *AuthorInputID) XXX_Merge(src proto.Message) {
	xxx_messageInfo_AuthorInputID.Merge(m, src)
}
func (m *AuthorInputID) XXX_Size() int {
	return xxx_messageInfo_AuthorInputID.Size(m)
}
func (m *AuthorInputID) XXX_DiscardUnknown() {
	xxx_messageInfo_AuthorInputID.DiscardUnknown(m)
}

var xxx_messageInfo_AuthorInputID proto.InternalMessageInfo

func (m *AuthorInputID) GetId() string {
	if m != nil {
		return m.Id
	}
	return ""
}

func init() {
	proto.RegisterType((*Author)(nil), "proto.Author")
	proto.RegisterType((*AuthorInput)(nil), "proto.AuthorInput")
	proto.RegisterType((*AuthorInputID)(nil), "proto.AuthorInputID")
}

func init() { proto.RegisterFile("author.proto", fileDescriptor_54cb4b5a5dd8ee3d) }

var fileDescriptor_54cb4b5a5dd8ee3d = []byte{
	// 184 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe2, 0xe2, 0x49, 0x2c, 0x2d, 0xc9,
	0xc8, 0x2f, 0xd2, 0x2b, 0x28, 0xca, 0x2f, 0xc9, 0x17, 0x62, 0x05, 0x53, 0x4a, 0x4e, 0x5c, 0x6c,
	0x8e, 0x60, 0x61, 0x21, 0x3e, 0x2e, 0xa6, 0xcc, 0x14, 0x09, 0x46, 0x05, 0x46, 0x0d, 0xce, 0x20,
	0xa6, 0xcc, 0x14, 0x21, 0x21, 0x2e, 0x96, 0xbc, 0xc4, 0xdc, 0x54, 0x09, 0x26, 0xb0, 0x08, 0x98,
	0x2d, 0x24, 0xc2, 0xc5, 0x9a, 0x9a, 0x9b, 0x98, 0x99, 0x23, 0xc1, 0x0c, 0x16, 0x84, 0x70, 0x94,
	0xcc, 0xb9, 0xb8, 0x21, 0x66, 0x78, 0xe6, 0x15, 0x94, 0x96, 0xc0, 0x35, 0x32, 0x62, 0xd3, 0xc8,
	0x84, 0xac, 0x51, 0x9e, 0x8b, 0x17, 0x49, 0xa3, 0xa7, 0x0b, 0xba, 0x1b, 0x8c, 0x6a, 0x61, 0x0a,
	0x82, 0x53, 0x8b, 0xca, 0x32, 0x93, 0x53, 0x85, 0x8c, 0xb9, 0x78, 0x9c, 0x8b, 0x52, 0x13, 0x4b,
	0x52, 0xa1, 0x8e, 0x16, 0x82, 0xf8, 0x46, 0x0f, 0xc9, 0x18, 0x29, 0x5e, 0x14, 0x31, 0x25, 0x06,
	0x21, 0x73, 0x2e, 0x3e, 0xb7, 0xcc, 0xbc, 0x14, 0x08, 0xdf, 0xa9, 0xd2, 0xd3, 0x45, 0x48, 0x04,
	0x53, 0x9b, 0xa7, 0x0b, 0x86, 0xc6, 0x24, 0x36, 0x30, 0xdf, 0x18, 0x10, 0x00, 0x00, 0xff, 0xff,
	0xe8, 0x2c, 0x2d, 0xc1, 0x3a, 0x01, 0x00, 0x00,
}

// Reference imports to suppress errors if they are not otherwise used.
var _ context.Context
var _ grpc.ClientConn

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
const _ = grpc.SupportPackageIsVersion4

// AuthorServiceClient is the client API for AuthorService service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://godoc.org/google.golang.org/grpc#ClientConn.NewStream.
type AuthorServiceClient interface {
	CreateAuthor(ctx context.Context, in *AuthorInput, opts ...grpc.CallOption) (*Author, error)
	FindAuthorByID(ctx context.Context, in *AuthorInputID, opts ...grpc.CallOption) (*Author, error)
}

type authorServiceClient struct {
	cc *grpc.ClientConn
}

func NewAuthorServiceClient(cc *grpc.ClientConn) AuthorServiceClient {
	return &authorServiceClient{cc}
}

func (c *authorServiceClient) CreateAuthor(ctx context.Context, in *AuthorInput, opts ...grpc.CallOption) (*Author, error) {
	out := new(Author)
	err := c.cc.Invoke(ctx, "/proto.AuthorService/CreateAuthor", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *authorServiceClient) FindAuthorByID(ctx context.Context, in *AuthorInputID, opts ...grpc.CallOption) (*Author, error) {
	out := new(Author)
	err := c.cc.Invoke(ctx, "/proto.AuthorService/FindAuthorByID", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// AuthorServiceServer is the server API for AuthorService service.
type AuthorServiceServer interface {
	CreateAuthor(context.Context, *AuthorInput) (*Author, error)
	FindAuthorByID(context.Context, *AuthorInputID) (*Author, error)
}

// UnimplementedAuthorServiceServer can be embedded to have forward compatible implementations.
type UnimplementedAuthorServiceServer struct {
}

func (*UnimplementedAuthorServiceServer) CreateAuthor(ctx context.Context, req *AuthorInput) (*Author, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CreateAuthor not implemented")
}
func (*UnimplementedAuthorServiceServer) FindAuthorByID(ctx context.Context, req *AuthorInputID) (*Author, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindAuthorByID not implemented")
}

func RegisterAuthorServiceServer(s *grpc.Server, srv AuthorServiceServer) {
	s.RegisterService(&_AuthorService_serviceDesc, srv)
}

func _AuthorService_CreateAuthor_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AuthorInput)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AuthorServiceServer).CreateAuthor(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/proto.AuthorService/CreateAuthor",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AuthorServiceServer).CreateAuthor(ctx, req.(*AuthorInput))
	}
	return interceptor(ctx, in, info, handler)
}

func _AuthorService_FindAuthorByID_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(AuthorInputID)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(AuthorServiceServer).FindAuthorByID(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/proto.AuthorService/FindAuthorByID",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(AuthorServiceServer).FindAuthorByID(ctx, req.(*AuthorInputID))
	}
	return interceptor(ctx, in, info, handler)
}

var _AuthorService_serviceDesc = grpc.ServiceDesc{
	ServiceName: "proto.AuthorService",
	HandlerType: (*AuthorServiceServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "CreateAuthor",
			Handler:    _AuthorService_CreateAuthor_Handler,
		},
		{
			MethodName: "FindAuthorByID",
			Handler:    _AuthorService_FindAuthorByID_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "author.proto",
}
